<?php

namespace Teknisa\TCO\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\Report\ReportService;

class Tco01600PrevisaoConsumo extends \Zeedhi\Framework\Controller\Report {
    
    protected $reportService; 
    protected $environment; 
    protected $birtStrategy; 
    protected $entityManager; 
    protected $listas; 
    protected $newCode; 
    
    public function __construct($reportService, $environment, $birtStrategy, $entityManager, $listas, $newCode) {
        $this->reportService = $reportService; 
        $this->environment = $environment; 
        $this->birtStrategy = $birtStrategy; 
        $this->entityManager = $entityManager; 
        $this->listas = $listas; 
        $this->newCode = $newCode; 
    }
    
    protected $reportMapping = array ( 
        'TCO01600' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'NRCARDAPIOTRAB'      => 'NRCARDAPIOTRAB',
                        'NRORG'               => 'NRORG',
                        'DSSEGMER'            => 'DSSEGMER',
                        'DSATIVCLI'           => 'DSATIVCLI',
                        'NMTIPOPUBLICO'       => 'NMTIPOPUBLICO',
                        'QTSEGSEX'            => 'QTSEGSEX',
                        'QTSABADO'            => 'QTSABADO',
                        'QTDOMFERI'           => 'QTDOMFERI',
                        'QTTURNOS'            => 'QTTURNOS',
                        'VRPEACRESCIMO'       => 'PEACRESCIMO',
                        'NIVELINDICE'         => 'NIVELINDICE',
                        'NRSEMANA_INICIAL'    => 'NRSEMANA_INICIAL',
                        'NRSEMANA_FINAL'      => 'NRSEMANA_FINAL',
                        'NRDIASEMANA_INICIAL' => 'NRDIASEMANA_INICIAL',
                        'NRDIASEMANA_FINAL'   => 'NRDIASEMANA_FINAL',
                        'IDORDENACAO'         => 'IDORDENACAO',
                        'IDARRENDONDAMENTO'   => 'IDARRENDONDAMENTO',
                        'CDARVPRODINI'        => 'CDARVPRODINI',
                        'CDARVPRODFIN'        => 'CDARVPRODFIN',
                        'LISTAPORCGRAMATURA'  => 'LISTAPORCGRAMATURA',
                        'CDSUBGRPROD'         => 'CDSUBGRPROD'
                    )
            ),
        'TCO01601' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'NRCARDAPIOTRAB'      => 'NRCARDAPIOTRAB',
                        'NRORG'               => 'NRORG',
                        'DSSEGMER'            => 'DSSEGMER',
                        'DSATIVCLI'           => 'DSATIVCLI',
                        'NMTIPOPUBLICO'       => 'NMTIPOPUBLICO',
                        'QTSEGSEX'            => 'QTSEGSEX',
                        'QTSABADO'            => 'QTSABADO',
                        'QTDOMFERI'           => 'QTDOMFERI',
                        'QTTURNOS'            => 'QTTURNOS',
                        'VRPEACRESCIMO'       => 'PEACRESCIMO',
                        'NIVELINDICE'         => 'NIVELINDICE',
                        'NRSEMANA_INICIAL'    => 'NRSEMANA_INICIAL',
                        'NRSEMANA_FINAL'      => 'NRSEMANA_FINAL',
                        'NRDIASEMANA_INICIAL' => 'NRDIASEMANA_INICIAL',
                        'NRDIASEMANA_FINAL'   => 'NRDIASEMANA_FINAL',
                        'IDORDENACAO'         => 'IDORDENACAO',
                        'IDARRENDONDAMENTO'   => 'IDARRENDONDAMENTO',
                        'CDARVPRODINI'        => 'CDARVPRODINI',
                        'CDARVPRODFIN'        => 'CDARVPRODFIN',
                        'LISTAPORCGRAMATURA'  => 'LISTAPORCGRAMATURA',
                        'CDSUBGRPROD'         => 'CDSUBGRPROD'
                    )
            ),
        'TCO01602' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'NRCARDAPIOTRAB'      => 'NRCARDAPIOTRAB',
                        'NRORG'               => 'NRORG',
                        'DSSEGMER'            => 'DSSEGMER',
                        'DSATIVCLI'           => 'DSATIVCLI',
                        'NMTIPOPUBLICO'       => 'NMTIPOPUBLICO',
                        'QTSEGSEX'            => 'QTSEGSEX',
                        'QTSABADO'            => 'QTSABADO',
                        'QTDOMFERI'           => 'QTDOMFERI',
                        'QTTURNOS'            => 'QTTURNOS',
                        'VRPEACRESCIMO'       => 'PEACRESCIMO',
                        'NIVELINDICE'         => 'NIVELINDICE',
                        'NRSEMANA_INICIAL'    => 'NRSEMANA_INICIAL',
                        'NRSEMANA_FINAL'      => 'NRSEMANA_FINAL',
                        'NRDIASEMANA_INICIAL' => 'NRDIASEMANA_INICIAL',
                        'NRDIASEMANA_FINAL'   => 'NRDIASEMANA_FINAL',
                        'IDORDENACAO'         => 'IDORDENACAO',
                        'IDARRENDONDAMENTO'   => 'IDARRENDONDAMENTO',
                        'CDARVPRODINI'        => 'CDARVPRODINI',
                        'CDARVPRODFIN'        => 'CDARVPRODFIN',
                        'LISTAPORCGRAMATURA'  => 'LISTAPORCGRAMATURA',
                        'CDSUBGRPROD'         => 'CDSUBGRPROD'
                    )
            ),
        'TCO01603' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'NRCARDAPIOTRAB'      => 'NRCARDAPIOTRAB',
                        'NRORG'               => 'NRORG',
                        'DSSEGMER'            => 'DSSEGMER',
                        'DSATIVCLI'           => 'DSATIVCLI',
                        'NMTIPOPUBLICO'       => 'NMTIPOPUBLICO',
                        'QTSEGSEX'            => 'QTSEGSEX',
                        'QTSABADO'            => 'QTSABADO',
                        'QTDOMFERI'           => 'QTDOMFERI',
                        'QTTURNOS'            => 'QTTURNOS',
                        'VRPEACRESCIMO'       => 'PEACRESCIMO',
                        'NIVELINDICE'         => 'NIVELINDICE',
                        'NRSEMANA_INICIAL'    => 'NRSEMANA_INICIAL',
                        'NRSEMANA_FINAL'      => 'NRSEMANA_FINAL',
                        'NRDIASEMANA_INICIAL' => 'NRDIASEMANA_INICIAL',
                        'NRDIASEMANA_FINAL'   => 'NRDIASEMANA_FINAL',
                        'IDORDENACAO'         => 'IDORDENACAO',
                        'IDARRENDONDAMENTO'   => 'IDARRENDONDAMENTO',
                        'CDARVPRODINI'        => 'CDARVPRODINI',
                        'CDARVPRODFIN'        => 'CDARVPRODFIN',
                        'LISTAPORCGRAMATURA'  => 'LISTAPORCGRAMATURA',
                        'CDSUBGRPROD'         => 'CDSUBGRPROD'
                    )
            ),
        'TCO01604' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'NRCARDAPIOTRAB'      => 'NRCARDAPIOTRAB',
                        'NRORG'               => 'NRORG',
                        'DSSEGMER'            => 'DSSEGMER',
                        'DSATIVCLI'           => 'DSATIVCLI',
                        'NMTIPOPUBLICO'       => 'NMTIPOPUBLICO',
                        'QTSEGSEX'            => 'QTSEGSEX',
                        'QTSABADO'            => 'QTSABADO',
                        'QTDOMFERI'           => 'QTDOMFERI',
                        'QTTURNOS'            => 'QTTURNOS',
                        'VRPEACRESCIMO'       => 'PEACRESCIMO',
                        'NIVELINDICE'         => 'NIVELINDICE',
                        'NRSEMANA_INICIAL'    => 'NRSEMANA_INICIAL',
                        'NRSEMANA_FINAL'      => 'NRSEMANA_FINAL',
                        'NRDIASEMANA_INICIAL' => 'NRDIASEMANA_INICIAL',
                        'NRDIASEMANA_FINAL'   => 'NRDIASEMANA_FINAL',
                        'IDORDENACAO'         => 'IDORDENACAO',
                        'IDARRENDONDAMENTO'   => 'IDARRENDONDAMENTO',
                        'CDARVPRODINI'        => 'CDARVPRODINI',
                        'CDARVPRODFIN'        => 'CDARVPRODFIN',
                        'LISTAPORCGRAMATURA'  => 'LISTAPORCGRAMATURA',
                        'CDSUBGRPROD'         => 'CDSUBGRPROD'
                    )
            ),
        'TCO01605' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'NRCARDAPIOTRAB'      => 'NRCARDAPIOTRAB',
                        'NRORG'               => 'NRORG',
                        'DSSEGMER'            => 'DSSEGMER',
                        'DSATIVCLI'           => 'DSATIVCLI',
                        'NMTIPOPUBLICO'       => 'NMTIPOPUBLICO',
                        'QTSEGSEX'            => 'QTSEGSEX',
                        'QTSABADO'            => 'QTSABADO',
                        'QTDOMFERI'           => 'QTDOMFERI',
                        'QTTURNOS'            => 'QTTURNOS',
                        'VRPEACRESCIMO'       => 'PEACRESCIMO',
                        'NIVELINDICE'         => 'NIVELINDICE',
                        'NRSEMANA_INICIAL'    => 'NRSEMANA_INICIAL',
                        'NRSEMANA_FINAL'      => 'NRSEMANA_FINAL',
                        'NRDIASEMANA_INICIAL' => 'NRDIASEMANA_INICIAL',
                        'NRDIASEMANA_FINAL'   => 'NRDIASEMANA_FINAL',
                        'IDORDENACAO'         => 'IDORDENACAO',
                        'IDARRENDONDAMENTO'   => 'IDARRENDONDAMENTO',
                        'CDARVPRODINI'        => 'CDARVPRODINI',
                        'CDARVPRODFIN'        => 'CDARVPRODFIN',
                        'LISTAPORCGRAMATURA'  => 'LISTAPORCGRAMATURA',
                        'CDSUBGRPROD'         => 'CDSUBGRPROD'
                    )
            ),
        'TCO01606' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'NRCARDAPIOTRAB'      => 'NRCARDAPIOTRAB',
                        'NRORG'               => 'NRORG',
                        'DSSEGMER'            => 'DSSEGMER',
                        'DSATIVCLI'           => 'DSATIVCLI',
                        'NMTIPOPUBLICO'       => 'NMTIPOPUBLICO',
                        'QTSEGSEX'            => 'QTSEGSEX',
                        'QTSABADO'            => 'QTSABADO',
                        'QTDOMFERI'           => 'QTDOMFERI',
                        'QTTURNOS'            => 'QTTURNOS',
                        'VRPEACRESCIMO'       => 'PEACRESCIMO',
                        'NIVELINDICE'         => 'NIVELINDICE',
                        'NRSEMANA_INICIAL'    => 'NRSEMANA_INICIAL',
                        'NRSEMANA_FINAL'      => 'NRSEMANA_FINAL',
                        'NRDIASEMANA_INICIAL' => 'NRDIASEMANA_INICIAL',
                        'NRDIASEMANA_FINAL'   => 'NRDIASEMANA_FINAL',
                        'IDORDENACAO'         => 'IDORDENACAO',
                        'IDARRENDONDAMENTO'   => 'IDARRENDONDAMENTO',
                        'CDARVPRODINI'        => 'CDARVPRODINI',
                        'CDARVPRODFIN'        => 'CDARVPRODFIN',
                        'LISTAPORCGRAMATURA'  => 'LISTAPORCGRAMATURA',
                        'CDSUBGRPROD'         => 'CDSUBGRPROD'
                    )
            )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $row["__report_name"] = $row["REPORT"];
        $row["NRORG"] = $this->environment->getNrorgTrab();
        $row["NIVELINDICE"] = $this->retornaIndiceCodigo($row);
        $row["QTSEGSEX"] = intval($row["QTSEGSEX"]);
        $row["QTSABADO"] = intval($row["QTSABADO"]);
        $row["QTDOMFERI"] = intval($row["QTDOMFERI"]);
        $row["QTTURNOS"] = intval($row["QTTURNOS"]);
        $value = str_replace('.', '', $row["VRPEACRESCIMO"]);
        $row["VRPEACRESCIMO"] = $value;
        $row["CDSUBGRPROD"] = $row["DESCON_NMSUBGRPROD"] == "S"? "T": $this->listas->criarListaValores(implode("_", $row["NMSUBGRPROD"]));
        try {
            if(sizeof($row["PORCGRAMATURA"]) > 0 && sizeof($row["TIPOPRATOSSELECIONADOS"]) > 0) {
                $row["LISTAPORCGRAMATURA"]     = $this->returnNumeroListaoPorcGramatura($row);
            } else {
                $row["PORCGRAMATURA"]          = $this->returnPorcGramatura($row);
                $row["LISTAPORCGRAMATURA"]     = $this->returnNumeroListaoPorcGramatura($row);
            }
            $this->birtStrategy->setReportFormat(strtolower($row['BIRTTYPE']));
        } catch(\Exception $e) {
            $response->setError($e->getMessage());
        }
    }
    
    private function retornaIndiceCodigo($row) {
        $cdpictprod = $this->retornaCdpictprod();
        $explodeCdpictprod = explode(".", $cdpictprod);
        $codigoExtraido = "";
        for($i = 0; $i <= ($row["TIPONIVEL"] - 1); $i++){
            $codigoExtraido.= $explodeCdpictprod[$i];
        }
        return strlen($codigoExtraido);
    }
    
    private function retornaCdpictprod() {
        
        $connection = $this->entityManager->getConnection();
        $sql = "SELECT CDPICTPROD
                  FROM PARAMGERAL
                 WHERE NRORG = :NRORG";
        
        $query = $connection->prepare($sql);
        
        $params = array(
            "NRORG"      => $this->environment->getNrorgTrab()
        ); 
        
        $query->execute($params);
        
        $result = $query->fetch(\PDO::FETCH_ASSOC);
        
        return $result["CDPICTPROD"];
        
    }
    
    private function returnNumeroListaoPorcGramatura($row) {
        $nrlista = $this->newCode->getCodeByTableName('LISTA', $this->environment->getNrorgTrab(), 1, 10, false);
        
        $decodeIdTipoGramatura = array(
            "INNATURA" => "In Natura", 
            "PRONTA" => "Pronta", 
            "LIMPA" => "Limpa",    
            "0" => "In Natura",
            "1" => "Limpa",
            "2" => "Pronta"
        );
        
        try{
            foreach($row["PORCGRAMATURA"] as $porcgramatura){
                $descPorcGramatura = $porcgramatura["NMGRTIPOPR"]." - ".$porcgramatura["NMPORCIONAMENTO"];
                if(isset($porcgramatura["NRGRAMATURACARDBASE"])){
                    $descPorcGramatura = $descPorcGramatura." - ".$porcgramatura["VRGRAMATURA"].$porcgramatura["SGUNIDADE"];
                    if(!empty($porcgramatura["IDTIPOGRAMATURA"]))
                        $descPorcGramatura = $descPorcGramatura." ".$decodeIdTipoGramatura[$porcgramatura["IDTIPOGRAMATURA"]];
                }
                $this->listas->insertLista($nrlista, substr($descPorcGramatura, 0, 50));
            }
            return $nrlista;
        } catch(\Exception $e){
            throw $e;
        }  
    }
    
    private function returnPorcGramatura($row) {
        $connection = $this->entityManager->getConnection();
        $sql = "SELECT DETALHESERVPROPCOM.NRCARDAPIOTRAB, 
                       DETALHESERVPROPCOM.NRDETALHESERVPROPCOM, 
                       CONFGRUPOTPPROPCOM.CDGRTIPOPR, 
                       GRTIPOPR.NMGRTIPOPR, 
                       CONFGRUPOTPPROPCOM.NRPORCIONAMENTO, 
                       PORCIONAMENTO.NMPORCIONAMENTO, 
                       CONFGRUPOTPPROPCOM.NRGRAMATURACARDBASE, 
                       GRAMATURACARDBASE.VRGRAMATURA, 
                       GRAMATURACARDBASE.SGUNIDADE, 
                       CONFGRUPOTPPROPCOM.IDTIPOGRAMATURA, 
                       DETALHESERVPROPCOM.NRORG 
                  FROM DETALHESERVPROPCOM 
                 INNER JOIN CONFGRUPOTPPROPCOM 
                    ON CONFGRUPOTPPROPCOM.NRDETALHESERVPROPCOM = DETALHESERVPROPCOM.NRDETALHESERVPROPCOM 
                 INNER JOIN GRTIPOPR 
                    ON GRTIPOPR.CDGRTIPOPR = CONFGRUPOTPPROPCOM.CDGRTIPOPR 
                 INNER JOIN PORCIONAMENTO 
                    ON PORCIONAMENTO.NRPORCIONAMENTO = CONFGRUPOTPPROPCOM.NRPORCIONAMENTO 
                  LEFT JOIN GRAMATURACARDBASE 
                    ON GRAMATURACARDBASE.NRGRAMATURACARDBASE = CONFGRUPOTPPROPCOM.NRGRAMATURACARDBASE 
                 WHERE DETALHESERVPROPCOM.NRCARDAPIOTRAB = :NRCARDAPIOTRAB 
                   AND DETALHESERVPROPCOM.NRORG = :NRORG";
        
        $query = $connection->prepare($sql);
        
        $params = array(
            "NRCARDAPIOTRAB" => $row["NRCARDAPIOTRAB"],
            "NRORG"          => $this->environment->getNrorgTrab()
        ); 
        
        $query->execute($params);
        
        $result = $query->fetchAll(\PDO::FETCH_ASSOC);
        
        return $result;
    }
    
}